#version 150 core

layout(points) in;
layout(triangle_strip, max_vertices = 4) out;

out VertexData
{
  vec2 texCoord;
} outData;

uniform sampler2D pos;
uniform sampler2D data;
uniform sampler2D tex;

uniform mat4 mat;

void main() {

    vec4 shipseldata1 = texelFetch(data, ivec2(gl_in[0].gl_Position.xy), 0);
    vec4 shipseldata2 = texelFetch(data, ivec2(gl_in[0].gl_Position.xy) + ivec2(1,0), 0);
    vec4 shipseldata3 = texelFetch(data, ivec2(gl_in[0].gl_Position.xy) + ivec2(0,1), 0);
    vec4 shipseldata4 = texelFetch(data, ivec2(gl_in[0].gl_Position.xy) + ivec2(1), 0);

    ivec2 samplepos;
    if (shipseldata1.x != 0)
    {
        samplepos = ivec2(gl_in[0].gl_Position.xy);
        gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy, 0, 1)).xy;
        outData.texCoord = samplepos;
        EmitVertex();

        if (shipseldata2.x != 0)
        {
            samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(1,0);
            gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy, 0, 1)).xy;
            outData.texCoord = samplepos;
            EmitVertex();

            if (shipseldata3.x != 0)
            {
                samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(0,1);
                gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy, 0, 1)).xy;
                outData.texCoord = samplepos;
                EmitVertex();

                if (shipseldata4.x != 0)
                {
                    samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(1,1);
                    gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy, 0, 1)).xy;
                    outData.texCoord = samplepos;
                    EmitVertex();
                }
            } else if (shipseldata4.x != 0)
            {
                samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(1,1);
                gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy, 0, 1)).xy;
                outData.texCoord = samplepos;
                EmitVertex();
            } else {
                samplepos = ivec2(gl_in[0].gl_Position.xy);
                gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy + vec2(0.1, 0.1), 0, 1)).xy;
                outData.texCoord = samplepos;
                EmitVertex();

                samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(1,0);
                gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy + vec2(0.1,0.1), 0, 1)).xy;
                outData.texCoord = samplepos;
                EmitVertex();
            }
        } else if (shipseldata3.x != 0)
        {
            samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(0,1);
            gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy, 0, 1)).xy;
            outData.texCoord = samplepos;
            EmitVertex();

            if (shipseldata4.x != 0)
            {
                samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(1,1);
                gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy, 0, 1)).xy;
                outData.texCoord = samplepos;
                EmitVertex();
            } else {
                samplepos = ivec2(gl_in[0].gl_Position.xy);
                gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy + vec2(0.1, 0.1), 0, 1)).xy;
                outData.texCoord = samplepos;
                EmitVertex();

                samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(0,1);
                gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy + vec2(0.1, 0.1), 0, 1)).xy;
                outData.texCoord = samplepos;
                EmitVertex();
            }
        } else if (shipseldata4.x != 0)
        {
            samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(1,1);
            gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy, 0, 1)).xy;
            outData.texCoord = samplepos;
            EmitVertex();

            samplepos = ivec2(gl_in[0].gl_Position.xy);
            gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy + vec2(-0.1, 0.1), 0, 1)).xy;
            outData.texCoord = samplepos;
            EmitVertex();

            samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(1,1);
            gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy + vec2(-0.1, 0.1), 0, 1)).xy;
            outData.texCoord = samplepos;
            EmitVertex();
        }

    } else if (shipseldata2.x != 0)
    {
        samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(1,0);
        gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy, 0, 1)).xy;
        outData.texCoord = samplepos;
        EmitVertex();

        if (shipseldata3.x != 0)
        {
            samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(0,1);
            gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy, 0, 1)).xy;
            outData.texCoord = samplepos;
            EmitVertex();

            if (shipseldata4.x != 0)
            {
                samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(1,1);
                gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy, 0, 1)).xy;
                outData.texCoord = samplepos;
                EmitVertex();
            } else {

                samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(1,0);
                gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy+ vec2(0.1, 0.1), 0, 1)).xy;
                outData.texCoord = samplepos;
                EmitVertex();

                samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(0,1);
                gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy+ vec2(0.1, 0.1), 0, 1)).xy;
                outData.texCoord = samplepos;
                EmitVertex();
            }
        } else if (shipseldata4.x != 0)
        {
            samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(1,1);
            gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy, 0, 1)).xy;
            outData.texCoord = samplepos;
            EmitVertex();

            samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(1,1);
            gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy, 0, 1)).xy;
            outData.texCoord = samplepos;
            EmitVertex();
        }
    } else if (shipseldata3.x != 0)
    {
        samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(0,1);
        gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy, 0, 1)).xy;
        outData.texCoord = samplepos;
        EmitVertex();

        if (shipseldata4.x != 0)
        {
            samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(1,1);
            gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy, 0, 1)).xy;
            outData.texCoord = samplepos;
            EmitVertex();

            samplepos = ivec2(gl_in[0].gl_Position.xy) + ivec2(1,1);
            gl_Position.xy = (mat * vec4(texelFetch(pos, samplepos, 0).xy, 0, 1)).xy;
            outData.texCoord = samplepos;
            EmitVertex();
        }
    }

    EndPrimitive();

}
