#version 330 core

in VertexData
{
  vec2 texCoord;
} inData;

layout(location = 0) out vec4 outcol;

uniform sampler2D tex;
uniform sampler2D data;

const vec4 wcol = vec4(0, 0.25, 1, 0.5);

void main() {

    ivec2 texsz = textureSize(tex, 0);

    vec2 coords = (inData.texCoord  + 0.5) / texsz;
    vec4 dat = texture(data, coords);
    if (dat.x == 0)
        discard;
        /*
    vec4 col  = vec4(0);
    col += texture(tex, coords + vec2(1,1) / texsz * 0.125);
    col += texture(tex, coords + vec2(-1,1) / texsz * 0.125);
    col += texture(tex, coords + vec2(1,-1) / texsz * 0.125);
    col += texture(tex, coords + vec2(-1,-1) / texsz * 0.125);
*/
    if (dat.w == 1)
        dat.z = 0;
	outcol = mix(texture(tex, coords), wcol, clamp(dat.z * wcol.w, 0, 1));
}
